# Architecture

This article provides an overview of the Designer product's architecture and the dependencies involved in its development and functionality.

## Designer Architecture

The following diagram displays the major components utilized by the Designer application that runs natively on the ServiceNow platform.

![Designer Architecture](/files/R9x0MrBkww2AeK3jXZ7q)

## Designer Extensions

The following tables are created within the Designer application scope **x\_inpgh\_des** and are exclusively used for the Designer application. ServiceNow tables and configurations are not changed.

| Label                    | Table                                    | Description                                                                                              |
| ------------------------ | ---------------------------------------- | -------------------------------------------------------------------------------------------------------- |
| Global Settings          | x\_inpgh\_des\_global\_settings          | Contains global settings of the Designer application set by the Designer admin                           |
| Filters                  | x\_inpgh\_des\_filters                   | Contains settings for personal and global filters                                                        |
| Elements                 | x\_inpgh\_des\_elements                  | Contains all committed and uncommitted elements used in all diagrams                                     |
| Diagrams                 | x\_inpgh\_des\_diagrams                  | Contains all diagrams created with Designer                                                              |
| Class Fields             | x\_inpgh\_des\_class\_fields             | Contains definitions for class fields                                                                    |
| Class Definitions        | x\_inpgh\_des\_class\_definitions        | Contains all Class Definitions defining the tables visible in the repository browser and default styling |
| Realtime Indicators      | x\_inpgh\_des\_indicators                | Contains all indicators defined per class/table                                                          |
| Indicator Breakdown      | x\_inpgh\_des\_indicator\_breakdown      | Contains all individual indicator breakdowns defined for an indicator                                    |
| Relationships            | x\_inpgh\_des\_relationships             | Contains all relationships used in all diagrams                                                          |
| User Settings            | x\_inpgh\_des\_user\_settings            | Contains personal user settings                                                                          |
| Templates                | x\_inpgh\_des\_templates                 | Contains all global and personal templates                                                               |
| Shape Libraries          | x\_inpgh\_des\_shape\_libraries          | Contains all shape libraries defined                                                                     |
| Shapes                   | x\_inpgh\_des\_shapes                    | Contains all individual shapes defined being part of a shape library                                     |
| Relationship Fields      | x\_inpgh\_des\_relationship\_fields      | Contains definitions for the relationship fields                                                         |
| Relationship Definitions | x\_inpgh\_des\_relationship\_definitions | Contains definitions and styles for relationships                                                        |

## Required ServiceNow Tables

The Designer application is included in the basic ServiceNow platform installation and does not require any additional modules. However, the application utilizes certain tables that are part of the standard ServiceNow installation. These tables are essential for visualizing relationships and dependencies within the ServiceNow application.

| Label                   | Table                    | Description                                                                       |
| ----------------------- | ------------------------ | --------------------------------------------------------------------------------- |
| Application Cross-Scope | sys\_scope\_privilege    | Table containing Read & Create rights to ServiceNow and other scoped applications |
| CI Relationships        | cmdb\_rel\_ci            | Table containing ServiceNow m2m relationships                                     |
| Relationship Types      | cmdb\_rel\_type          | Table containing ServiceNow relationship types                                    |
| Suggested Relationships | cmdb\_rel\_type\_suggest | Table containing ServiceNow relationship definitions between 2 tables (classes)   |
| Any Table               | e.g. cmdb\_ci\_service   | Any table in ServiceNow—including custom and scoped tables                        |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.ins-pi.com/designer/reference/architecture.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
